//+------------------------------------------------------------------+
//|                                                Rsi BlackFeet.mq4 |
//|                                                           .....h |
//|                                                 hayseedville.com |
//+------------------------------------------------------------------+
#property copyright ".....h"
#property link      "hayseedville.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red




extern int    rsipds          = 21;
extern int    ema             = 21;
extern int    rsiapprice      = 0;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";     



double CrossUp[];
double CrossDn[];
double rsi[];
double rsifastma[];
double trend[];


//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,233);
   SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,234); 
   SetIndexBuffer(2,rsi);
   SetIndexBuffer(3,rsifastma); 
   SetIndexBuffer(4,trend);   
   return(0); 
} 

//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() { 
   return(0);
} 

//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--) rsi[i]       = iRSI(NULL,0,rsipds,rsiapprice,i);
   for (i=limit; i>=0; i--) rsifastma[i] = iMAOnArray(rsi,0,ema,1,0,i);    
   for (i=limit; i>=0; i--)
   {
      trend[i] = 0;  
      if (rsi[i]>rsifastma[i]) trend[i] = 1;
      if (rsi[i]<rsifastma[i]) trend[i] =-1;
      
      //
      //
      //
      //
      //
      
      CrossUp[i] = EMPTY_VALUE;
      CrossDn[i] = EMPTY_VALUE;
      if (trend[i]!= trend[i+1])
      if (trend[i] == 1)
            CrossUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
      else  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2;
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("Buy");
      else  doAlert("Sell");       
   }

return(0);
}
   
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Rsi Blackfeet ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Rsi Blackfeet "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}